-- [[ Create ReloadUI() Slashcommand ]]--
SLASH_GMRELOADUI1 = "/rel";
SlashCmdList["GMRELOADUI"] = ReloadUI;


function GMMenu_OnLoad()
	--[[ Set Table for GUI Functions ]]--
	GMMenu = {
		["functions"] = {
			["GMMenu_Category_Give_Gold"] = function(text)
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Give_Gold\"]("..text..")")
				ExecuteMacroLine("/gm ? givemoney "..text)
			end,
			["GMMenu_Category_Give_Dias"] = function(text)
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Give_Dias\"]("..text..")")
				ExecuteMacroLine("/gm ? givemoney_account "..text)
			end,
			["GMMenu_Category_Give_Ruby"] = function(text)
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Give_Ruby\"]("..text..")")
				ExecuteMacroLine("/gm ? givemoney_bonus "..text)
			end,
			["GMMenu_Category_Give_Phirius"] = function(text)
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Give_Phirius\"]("..text..")")
				ExecuteMacroLine("/gm ? give 203038 "..text)
			end,
			["GMMenu_Category_Give_Item"] = function(text)
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Give_Item\"]("..text..")")
				ExecuteMacroLine("/gm ? give "..text)
			end,
			["GMMenu_Category_Give_LittleDeath"] = function()
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Give_LittleDeath\"]()")
				ExecuteMacroLine("/gm ? give 203091")
				UseItemByName("Transformation Potion - Little Death")
				UseItemByName("Transformationstrank - Kleiner Tod")
			end,
			["GMMenu_Category_Character_SetLevel"] = function(text)
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Character_SetLevel\"]("..text..")")
				ExecuteMacroLine("/gm ? setvalue lv "..text)
			end,
			["GMMenu_Category_Character_GiveTP"] = function()
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Character_GiveTP\"]()")
				ExecuteMacroLine("/gm ? give 203067 10")
			end,
			["GMMenu_Category_Character_SetMainClass"] = function()
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Character_SetMainClass\"]()")
				GMMenu_OpenSelection("Change Primary Class", "MainClass")
			end,
			["GMMenu_Category_Character_SetSecClass"] = function()
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Character_SetSecClass\"]()")
				GMMenu_OpenSelection("Change Secondary Class", "SecClass")
			end,
			["GMMenu_Category_Character_SetRace"] = function()
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Character_SetRace\"]()")
				GMMenu_OpenSelection("Change Race / Sex", "Race")
			end,
			["GMMenu_Category_Character_Hide"] = function()
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Character_Hide\"]()")
				ExecuteMacroLine("/gm ? gmhide")
			end,
			["GMMenu_Category_Character_AttackFlag"] = function()
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Character_AttackFlag\"]()")
				ExecuteMacroLine("/gm ? attackflag")
			end,
			["GMMenu_Category_Character_ResetEquipment"] = function()
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Character_ResetEquipment\"]()")
				GMMenu_ResetEQFrame:Show()
			end,
			["GMMenu_Category_Teleport_Zone"] = function()
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Teleport_Zone\"]()")
				GMMenu_OpenSelection("Teleport To Zone", "Zone")
			end,
			["GMMenu_Category_Teleport_Instance"] = function()
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_Category_Teleport_Instance\"]()")
				GMMenu_OpenSelection("Teleport To Instance", "Instance")
			end,
			["GMMenu_ResetEQ"] = function()
				-- printmessage("executing: GMMenu[\"functions\"][\"GMMenu_ResetEQ\"]()")
				GMMenu_ResetEQ_Plus = GMMenu_ResetEQFrame_PlusEditBox:GetText()
				GMMenu_ResetEQ_Rarity = GMMenu_ResetEQFrame_RarityEditBox:GetText()
				-- printmessage("plus: "..GMMenu_ResetEQ_Plus..", rarity: "..GMMenu_ResetEQ_Rarity)
				ExecuteMacroLine("/gm ? reseteq "..GMMenu_ResetEQ_Plus.." "..GMMenu_ResetEQ_Rarity)
			end,
			["SelectList"] = {
				["Instance"] = function(ID)
					-- printmessage("executing: GMMenu[\"functions\"][\"SelectList\"][\"Instance\"]("..ID..")")
					-- printmessage("values: title="..GMMenu["SelectLists"]["Instance"][tostring(ID)]["title"]..", value="..GMMenu["SelectLists"]["Instance"][tostring(ID)]["value"])
					ExecuteMacroLine("/gm ? zone "..GMMenu["SelectLists"]["Instance"][tostring(ID)]["value"])
				end,
				["Zone"] = function(ID)
					-- printmessage("executing: GMMenu[\"functions\"][\"SelectList\"][\"Zone\"]("..ID..")")
					-- printmessage("values: title="..GMMenu["SelectLists"]["Zone"][tostring(ID)]["title"]..", value="..GMMenu["SelectLists"]["Zone"][tostring(ID)]["value"])
					ExecuteMacroLine("/gm ? zone "..GMMenu["SelectLists"]["Zone"][tostring(ID)]["value"])
				end,
				["Race"] = function(ID)
					-- printmessage("executing: GMMenu[\"functions\"][\"SelectList\"][\"Race\"]("..ID..")")
					-- printmessage("values: title="..GMMenu["SelectLists"]["Race"][tostring(ID)]["title"]..", value="..GMMenu["SelectLists"]["Race"][tostring(ID)]["value"])
					ExecuteMacroLine("/gm ? setvalue sex "..GMMenu["SelectLists"]["Race"][tostring(ID)]["value"])
				end,
				["MainClass"] = function(ID)
					-- printmessage("executing: GMMenu[\"functions\"][\"SelectList\"][\"MainClass\"]("..ID..")")
					-- printmessage("values: title="..GMMenu["SelectLists"]["MainClass"][tostring(ID)]["title"]..", value="..GMMenu["SelectLists"]["MainClass"][tostring(ID)]["value"])
					ExecuteMacroLine("/gm ? setvalue job "..GMMenu["SelectLists"]["MainClass"][tostring(ID)]["value"])
				end,
				["SecClass"] = function(ID)
					-- printmessage("executing: GMMenu[\"functions\"][\"SelectList\"][\"SecClass\"]("..ID..")")
					-- printmessage("values: title="..GMMenu["SelectLists"]["SecClass"][tostring(ID)]["title"]..", value="..GMMenu["SelectLists"]["SecClass"][tostring(ID)]["value"])
					ExecuteMacroLine("/gm ? setvalue subjob "..GMMenu["SelectLists"]["SecClass"][tostring(ID)]["value"])
				end,
			},
		},
		["SelectLists"] = {
			["Race"] ={
				["number"] = 4,
				["1"] = {
					["title"] = "Human Male",
					["value"] = 0,
				},
				["2"] = {
					["title"] = "Human Female",
					["value"] = 1,
				},
				["3"] = {
					["title"] = "Elv Male",
					["value"] = 2,
				},
				["4"] = {
					["title"] = "Elf Female",
					["value"] = 3,
				},
			},
			["MainClass"] ={
				["number"] = 9,
				["1"] = {
					["title"] = "Gamemaster",
					["value"] = 0,
				},
				["2"] = {
					["title"] = "Warrior",
					["value"] = 1,
				},
				["3"] = {
					["title"] = "Scout",
					["value"] = 2,
				},
				["4"] = {
					["title"] = "Rogue",
					["value"] = 3,
				},
				["5"] = {
					["title"] = "Mage",
					["value"] = 4,
				},
				["6"] = {
					["title"] = "Priest",
					["value"] = 5,
				},
				["7"] = {
					["title"] = "Knight",
					["value"] = 6,
				},
				["8"] = {
					["title"] = "Warden",
					["value"] = 7,
				},
				["9"] = {
					["title"] = "Druid",
					["value"] = 8,
				},
				
			},
			["SecClass"] ={
				["number"] = 9,
				["1"] = {
					["title"] = "Gamemaster",
					["value"] = 0,
				},
				["2"] = {
					["title"] = "Warrior",
					["value"] = 1,
				},
				["3"] = {
					["title"] = "Scout",
					["value"] = 2,
				},
				["4"] = {
					["title"] = "Rogue",
					["value"] = 3,
				},
				["5"] = {
					["title"] = "Mage",
					["value"] = 4,
				},
				["6"] = {
					["title"] = "Priest",
					["value"] = 5,
				},
				["7"] = {
					["title"] = "Knight",
					["value"] = 6,
				},
				["8"] = {
					["title"] = "Warden",
					["value"] = 7,
				},
				["9"] = {
					["title"] = "Druid",
					["value"] = 8,
				},
				
			},
			["Instance"] = {
				["number"] = 32,
				["1"] = {
					["title"] = "Barren Caves",
					["value"] = "110 0 1715 150 1380",
				},
				["2"] = {
					["title"] = "Forsaken Abbey",
					["value"] = "102 0 1244 320 2905",
				},
				["3"] = {
					["title"] = "Necropolis of Mirrors",
					["value"] = "103 0 683 -107 782",
				},
				["4"] = {
					["title"] = "Mystic Altar",
					["value"] = "104 0 912 984 1795",
				},
				["5"] = {
					["title"] = "Queens Chamber",
					["value"] = "105 0 1496 391 1241",
				},
				["6"] = {
					["title"] = "Paspers Shrine",
					["value"] = "106 0 2801 79 3001",
				},
				["7"] = {
					["title"] = "Shrine of Kalin",
					["value"] = "107 0 4721 680 854",
				},
				["8"] = {
					["title"] = "Treasure Trove",
					["value"] = "108 0 3111 711 686",
				},
				["9"] = {
					["title"] = "Ruins of the Ice Dwarf Kingdom 35",
					["value"] = "113 0 4305 229 2553",
				},
				["10"] = {
					["title"] = "Ruins of the Ice Dwarf Kingdom 50",
					["value"] = "114 0 4305 229 2553",
				},
				["11"] = {
					["title"] = "Cyclops Lair",
					["value"] = "252",
				},
				["12"] = {
					["title"] = "Heart of the Ocean",
					["value"] = "115 0 2399 657 3305",
				},
				["13"] = {
					["title"] = "Hall of Survivors",
					["value"] = "117 0 -1465 1437 -2710",
				},
				["14"] = {
					["title"] = "Dungeon of Dalanis",
					["value"] = "127 0 1771 433 2881",
				},
				["15"] = {
					["title"] = "Origin",
					["value"] = "116 0 1437 188 942",
				},
				["16"] = {
					["title"] = "Cave of the Water Dragon",
					["value"] = "118 0 0 670 -2028",
				},
				["17"] = {
					["title"] = "Lair of the Demon Dragon",
					["value"] = "119 0 3330 1491 3506",
				},
				["18"] = {
					["title"] = "Zuridon Stronghold",
					["value"] = "120 0 605 1006 423",
				},
				["19"] = {
					["title"] = "Hall of the Demon Lord",
					["value"] = "122 0 -303 755 717",
				},
				["20"] = {
					["title"] = "Warnorken Arena",
					["value"] = "129 0 2025 513 1909",
				},
				["21"] = {
					["title"] = "Raksha Temple",
					["value"] = "130 0 1870 88 452",
				},
				["22"] = {
					["title"] = "Kawak's Tomb",
					["value"] = "134 0 1382 891 -2862",
				},
				["23"] = {
					["title"] = "Varanas Nightmare",
					["value"] = "208 0 782 117 -1715",
				},
				["24"] = {
					["title"] = "Ruinen des Koenigreichs von Magnork",
					["value"] = "210 0 -1375 118 153",
				},
				["25"] = {
					["title"] = "Fungus Habitat",
					["value"] = "301",
				},
				["26"] = {
					["title"] = "Bloody Gallery",
					["value"] = "201",
				},
				["27"] = {
					["title"] = "Windmill Basement",
					["value"] = "250",
				},
				["28"] = {
					["title"] = "Arcane Chamber of Sathkur",
					["value"] = "251",
				},
				["29"] = {
					["title"] = "Wind Wild Animus",
					["value"] = "302",
				},
				["30"] = {
					["title"] = "Grafu Castle Hard Mode",
					["value"] = "136 0 352 1269 -1456",
				},
				["31"] = {
					["title"] = "Grafu Castle Normal Mode",
					["value"] = "137 0 352 1269 -1456",
				},
				["32"] = {
					["title"] = "Sardo Castle",
					["value"] = "139 0 909 1470 -1420",
				},

			},
			["Zone"] = {
				["number"] = 27,
				["1"] = {
					["title"] = "Tutorial Zone",
					["value"] = "100",
				},
				["2"] = {
					["title"] = "Howling Mountains",
					["value"] = "1",
				},
				["3"] = {
					["title"] = "Silverspring",
					["value"] = "2",
				},
				["4"] = {
					["title"] = "Ravenfell",
					["value"] = "3",
				},
				["5"] = {
					["title"] = "Aslan",
					["value"] = "4",
				},
				["6"] = {
					["title"] = "Ystra",
					["value"] = "5",
				},
				["7"] = {
					["title"] = "Dust Devil Canyon",
					["value"] = "6",
				},
				["8"] = {
					["title"] = "Weeping Coast",
					["value"] = "7",
				},
				["9"] = {
					["title"] = "Wild Lands",
					["value"] = "8",
				},
				["10"] = {
					["title"] = "Autoliano Vulcano",
					["value"] = "9 0 -11038 972 26259",
				},
				["11"] = {
					["title"] = "Thunderhoof Hills",
					["value"] = "15",
				},
				["12"] = {
					["title"] = "Southern Janost Forest",
					["value"] = "16",
				},
				["13"] = {
					["title"] = "Northern Janost Forest",
					["value"] = "17",
				},
				["14"] = {
					["title"] = "Limo Desert",
					["value"] = "18",
				},
				["15"] = {
					["title"] = "Sascilia Steppes",
					["value"] = "10",
				},
				["16"] = {
					["title"] = "Dragonfang Ridge",
					["value"] = "11",
				},
				["17"] = {
					["title"] = "Elven Island",
					["value"] = "12",
				},
				["18"] = {
					["title"] = "Wedding Hall",
					["value"] = "303",
				},

				["19"] = {
					["title"] = "Karros Canyon",
					["value"] = "431",
				},
				["20"] = {
					["title"] = "Visdun Fortress",
					["value"] = "445",
				},
				["21"] = {
					["title"] = "Tyrefen Mountain Range",
					["value"] = "446",
				},
				["22"] = {
					["title"] = "Vermillia Basin",
					["value"] = "450",
				},
				["23"] = {
					["title"] = "Lands of Malevolence",
					["value"] = "19",
				},
				["24"] = {
					["title"] = "Redhill Mountains",
					["value"] = "20",
				},
				["25"] = {
					["title"] = "Coast of Opportunity",
					["value"] = "13",
				},
				["26"] = {
					["title"] = "Xaviera",
					["value"] = "14",
				},
				["27"] = {
					["title"] = "Fireboot underground fortress",
					["value"] = "80",
				},

			},
		},
	}
	
	--[[ Set FontString Texts ]]--
	-- Window Title
	GMMenu_Title:SetText("Gamemaster Menu 2.0")
	
	-- Category Give
	GMMenu_Category_Give_Title:SetText("Add Items / Money")
		-- Gold
		GMMenu_Category_Give_Gold_Button:SetText("Gold")
		GMMenu_Category_Give_Gold_EditBox:SetText(1000000)
		-- Diamonds
		GMMenu_Category_Give_Dias_Button:SetText("Diamonds")
		GMMenu_Category_Give_Dias_EditBox:SetText(1000000)
		-- Rubys
		GMMenu_Category_Give_Ruby_Button:SetText("Rubys")
		GMMenu_Category_Give_Ruby_EditBox:SetText(1000)
		-- Phirius
		GMMenu_Category_Give_Phirius_Button:SetText("Phirius")
		GMMenu_Category_Give_Phirius_EditBox:SetText(1000)
		-- Item by ID
		GMMenu_Category_Give_Item_Button:SetText("Item by ID")
		GMMenu_Category_Give_Item_EditBox:SetText(203091)
		-- Little Death
		GMMenu_Category_Give_LittleDeath:SetText("Give Little Death and use it")
	
	-- Category Character
	GMMenu_Category_Character_Title:SetText("Character")
		-- Set Level
		GMMenu_Category_Character_SetLevel_Button:SetText("Set Level")
		GMMenu_Category_Character_SetLevel_EditBox:SetText(60)
		-- Give TP
		GMMenu_Category_Character_GiveTP:SetText("Give 10 Talent Orbs")
		-- Set Main Class
		GMMenu_Category_Character_SetMainClass:SetText("Change Primary Class")
		-- Set Secondary Class
		GMMenu_Category_Character_SetSecClass:SetText("Change Secondary Class")
		-- Set Race
		GMMenu_Category_Character_SetRace:SetText("Change Race or Sex")
		-- Hide
		GMMenu_Category_Character_Hide:SetText("Hide")
		-- Switch Attack Flag
		GMMenu_Category_Character_AttackFlag:SetText("Switch Attack Flag")
		-- Change Equipment
		GMMenu_Category_Character_ResetEquipment:SetText("Change Equipment")
	
	-- Category Teleport
	GMMenu_Category_Teleport_Title:SetText("Teleport")
		-- To Zone
		GMMenu_Category_Teleport_Zone:SetText("To Zone")
		-- To Instance
		GMMenu_Category_Teleport_Instance:SetText("To Instance")
	
	-- Author Label
	GMMenu_AboutAuthor_Label:SetText("Original by Gonium, rewritten by Teaior")

end

function GMMenu_ResetEQ_OnLoad()
	-- Change Equipment Frame
	GMMenu_ResetEQFrame_Title:SetText("Equipment")
	GMMenu_ResetEQFrame_PlusEditBox:SetText(20)
	GMMenu_ResetEQFrame_PlusEditBox_Title:SetText("Plus")
	GMMenu_ResetEQFrame_RarityEditBox:SetText(1)
	GMMenu_ResetEQFrame_RarityEditBox_Title:SetText("Rarity")
	GMMenu_ResetEQFrame_Do:SetText("Change Equipment!")
end
-- [[ Helper Functions ]]--
function printmessage(text)
	ChatFrame1:AddMessage(text)
end

function GMMenu_SetupSelectFrame(this)
	GMMenu_SelectList_List = "Instance"
	GMMenu_SelectList_ScrollFrame = this
	UIPanelScrollFrame_OnLoad(this)
	gmmenuscrollbar = getglobal(this:GetName().."ScrollBar")
	gmmenuscrollbar:SetMinMaxValues(0,1650)
	gmmenuscrollbar.scrollframe = GMMenu_SelectList_ScrollFrame
	
	GMMenu_SelectFrame_List_Button1:ClearAllAnchors()
	GMMenu_SelectFrame_List_Button1:SetAnchor("TOP", "TOP", "GMMenu_SelectFrame_List", 0, 1)
	GMMenu_SelectFrame_List_Button1_Label:SetText("Button 1")
	for i = 2, 75 do
		getglobal("GMMenu_SelectFrame_List_Button"..i):ClearAllAnchors()
		getglobal("GMMenu_SelectFrame_List_Button"..i):SetAnchor("TOP", "BOTTOM", "GMMenu_SelectFrame_List_Button"..(i-1), 0, 1)
	end
end

function GMMenu_ChangeSelectFrameScrollBar(buttonnum)
	GMMenu_SelectList_ScrollFrame_MaxValue = (buttonnum * 25) - 226
	gmmenuscrollbar:SetMinMaxValues(0,GMMenu_SelectList_ScrollFrame_MaxValue)
	gmmenuscrollbar.scrollframe = GMMenu_SelectList_ScrollFrame
end

function GMMenu_OpenSelection(selectiontitle, selectiontype)
	GMMenu_SelectFrame_Title:SetText(selectiontitle)
	GMMenu_SelectList_List = selectiontype
	GMMenu_SelectList_Number = GMMenu["SelectLists"][GMMenu_SelectList_List]["number"]
	GMMenu_ChangeSelectFrameScrollBar(GMMenu_SelectList_Number)
	for i = 1, GMMenu_SelectList_Number do
		GMMenu_SelectList_Text = GMMenu["SelectLists"][GMMenu_SelectList_List][tostring(i)]["title"] or ""
		getglobal("GMMenu_SelectFrame_List_Button"..i.."_Label"):SetText(GMMenu_SelectList_Text)
		getglobal("GMMenu_SelectFrame_List_Button"..i):Show()
	end
	for i = GMMenu_SelectList_Number + 1, 75 do
		GMMenu_SelectList_Text = ""
		getglobal("GMMenu_SelectFrame_List_Button"..i.."_Label"):SetText(GMMenu_SelectList_Text)
		getglobal("GMMenu_SelectFrame_List_Button"..i):Hide()
	end
	GMMenu_SelectFrame:Show()
end
